﻿using Telerik.Windows.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using System.Windows;
using System.Windows.Shapes;

namespace CustomCaps
{
    public class CustomConnection : RadDiagramConnection
    {
        private Path deferredPath;

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this.deferredPath = GetTemplateChild("DeferredPath") as Path;
        }

        protected override Geometry CreateGeometry(Telerik.Windows.Diagrams.Core.BridgeType bridgeType, bool roundedCorners)
        {
            // This will be called when you create Connection from a Connector.
            return base.CreateGeometry(bridgeType, roundedCorners);
        }

        protected override void UpdateDeferredGeometry(Point start, Point end, Point[] points)
        {
            // Create custom geometry:
            var newGeometry = new RectangleGeometry(new Rect(start, end));
            if (this.deferredPath != null) this.deferredPath.Data = newGeometry;

            //// Or change the data for the base method:
            //var center = new Point(Math.Abs(start.X - end.X) / 2, Math.Abs(start.Y - end.Y) / 2); 
            //var newPoints = new List<Point>(points);
            //newPoints.Add(new Point(center.X, center.Y - 50));
            //newPoints.Add(new Point(center.X, center.Y + 50));
            //base.UpdateDeferredGeometry(start, end, newPoints.ToArray());
        }
    }
}
